#!/usr/bin/python
#
# Progress bar for Update Agent
# Copyright (c) 1999-2002 Red Hat, Inc.
#
# Author: Preston Brown <pbrown@redhat.com>

import gtk
import gtk.gdk
#from gtk import glade
from gtk import TRUE, FALSE

class Progress:
    def __init__(self):
        self.xml = gtk.glade.XML("/usr/share/rhn/up2date_client/progress.glade", "progressWindow")
        self.progressWindow = self.xml.get_widget("progressWindow")
        self.progressWindow.connect("delete-event", self.progressWindow.hide)
        #self.progressWindow.connect("hide", self.progressWindow.hide)
        cursor = gtk.gdk.Cursor(gtk.gdk.WATCH)
        self.progressWindow.window.set_cursor(cursor)
        while gtk.events_pending():
            gtk.mainiteration(FALSE)

        self.lastProgress = 0.0

    def hide(self):
        self.progressWindow.hide()
        while gtk.events_pending():
            gtk.mainiteration(FALSE)
            
        del self

    def setLabel(self, text):
        label = self.xml.get_widget("progressLabel")
        label.set_text(text)
        while gtk.events_pending():
            gtk.mainiteration(FALSE)
        
    # the xmlrpc callbacks only use the first three
    # the GET style use all 4, so pass em but dont use them
    def setProgress(self, amount, total, speed = 0, secs = 0):
        if total:
            i = float(amount) / total
        else: 
            i = 1
        
        if i > 1:
            i = 1
        if i > self.lastProgress + .01 or i == 1:
            self.xml.get_widget("progressBar").set_fraction(i)
            if i == 1:
                # reset
                i = 0
#            gtk.gdk_flush()
            while gtk.events_pending():
                gtk.mainiteration(FALSE)
            self.lastProgress = i


    def destroy(self):
        while gtk.events_pending():
            gtk.mainiteration(FALSE)

        self.progressWindow.destroy()
 
    def noop(self, win, event):
        return TRUE

